Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkTetra Class Reference

`#include <vtkTetra.h>`

Inheritance diagram for vtkTetra:

[legend]
Collaboration diagram for vtkTetra:

[legend]
List of all members.

## Detailed Description

a 3D cell that represents a tetrahedron

Date:
  2002/12/26 18:24:22

Revision:
  1.74

vtkTetra is a concrete implementation of vtkCell to represent a 3D tetrahedron. vtkTetra uses the standard isoparametric shape functions for a linear tetrahedron. The tetrahedron is defined by the four points (0-3); where (0,1,2) is the base of the tetrahedron which, using the right hand rule, forms a triangle whose normal points in the direction of the fourth point.

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (67%)
  - Martin, Ken (12%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkTetra.cxx)`
  - .`h` (`/Common/vtkTetra.h)`

Examples:
  vtkTetra (Examples)

Tests:
  vtkTetra (Tests)

Definition at line 56 of file vtkTetra.h.

## Public Types
typedef vtkCell3D | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
int | CellBoundary (int subId, float pcoords[3], vtkIdList *pts)
int | GetParametricCenter (float pcoords[3])
int | JacobianInverse (double **inverse, float derivs[12])
virtual void | GetEdgePoints (int edgeId, int *&pts)
virtual void | GetFacePoints (int faceId, int *&pts)
virtual float * | GetParametricCoords ()
int | GetCellType ()
int | GetNumberOfEdges ()
int | GetNumberOfFaces ()
vtkCell * | GetEdge (int edgeId)
vtkCell * | GetFace (int faceId)
void | Contour (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd)
void | Clip (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *connectivity, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd, int insideOut)
int | EvaluatePosition (float x[3], float *closestPoint, int &subId, float pcoords[3], float &dist2, float *weights)
void | EvaluateLocation (int &subId, float pcoords[3], float x[3], float *weights)
int | IntersectWithLine (float p1[3], float p2[3], float tol, float &t, float x[3], float pcoords[3], int &subId)
int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts)
void | Derivatives (int subId, float pcoords[3], float *values, int dim, float *derivs)
## Static Public Methods
vtkTetra * | New ()
int | IsTypeOf (const char *type)
vtkTetra * | SafeDownCast (vtkObject *o)
void | TetraCenter (float p1[3], float p2[3], float p3[3], float p4[3], float center[3])
double | Circumsphere (double p1[3], double p2[3], double p3[3], double p4[3], double center[3])
double | Insphere (double p1[3], double p2[3], double p3[3], double p4[3], double center[3])
int | BarycentricCoords (double x[3], double x1[3], double x2[3], double x3[3], double x4[3], double bcoords[4])
double | ComputeVolume (double p1[3], double p2[3], double p3[3], double p4[3])
void | InterpolationFunctions (float pcoords[3], float weights[4])
void | InterpolationDerivs (float derivs[12])
int * | GetEdgeArray (int edgeId)
int * | GetFaceArray (int faceId)
## Protected Methods
| vtkTetra ()
| ~vtkTetra ()
## Protected Attributes
vtkLine * | Line
vtkTriangle * | Triangle

## Member Typedef Documentation

typedef vtkCell3D vtkTetra::Superclass

| Reimplemented from vtkCell3D. Definition at line 60 of file vtkTetra.h.

## Constructor & Destructor Documentation

vtkTetra::vtkTetra | ( |  | ) | `[protected]`

vtkTetra::~vtkTetra | ( |  | ) | `[protected]`

## Member Function Documentation

vtkTetra* vtkTetra::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkTetra::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkCell3D.

int vtkTetra::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCell3D.

virtual int vtkTetra::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCell3D.

vtkTetra* vtkTetra::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkCell3D.

virtual void vtkTetra::GetEdgePoints | ( | int | edgeId,
|  | int *& | pts
| ) | `[virtual]`

| See vtkCell3D API for description of these methods. Implements vtkCell3D.

virtual void vtkTetra::GetFacePoints | ( | int | faceId,
|  | int *& | pts
| ) | `[virtual]`

| See vtkCell3D API for description of these methods. Implements vtkCell3D.

virtual float* vtkTetra::GetParametricCoords | ( |  | ) | `[virtual]`

| See vtkCell3D API for description of these methods. Reimplemented from vtkCell3D.

int vtkTetra::GetCellType | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 71 of file vtkTetra.h. References VTK_TETRA.

int vtkTetra::GetNumberOfEdges | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 72 of file vtkTetra.h.

int vtkTetra::GetNumberOfFaces | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 73 of file vtkTetra.h.

vtkCell* vtkTetra::GetEdge | ( | int | edgeId | ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

vtkCell* vtkTetra::GetFace | ( | int | faceId | ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkTetra::Contour | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | verts,
|  | vtkCellArray * | lines,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkTetra::Clip | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | connectivity,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd,
|  | int | insideOut
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Reimplemented from vtkCell3D.

int vtkTetra::EvaluatePosition | ( | float | x[3],
|  | float * | closestPoint,
|  | int & | subId,
|  | float | pcoords[3],
|  | float & | dist2,
|  | float * | weights
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkTetra::EvaluateLocation | ( | int & | subId,
|  | float | pcoords[3],
|  | float | x[3],
|  | float * | weights
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkTetra::IntersectWithLine | ( | float | p1[3],
|  | float | p2[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkTetra::Triangulate | ( | int | index,
|  | vtkIdList * | ptIds,
|  | vtkPoints * | pts
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkTetra::Derivatives | ( | int | subId,
|  | float | pcoords[3],
|  | float * | values,
|  | int | dim,
|  | float * | derivs
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkTetra::CellBoundary | ( | int | subId,
|  | float | pcoords[3],
|  | vtkIdList * | pts
| ) | `[virtual]`

| Returns the set of points that are on the boundary of the tetrahedron that are closest parametrically to the point specified. This may include faces, edges, or vertices. Implements vtkCell.

int vtkTetra::GetParametricCenter | ( | float | pcoords[3] | ) | `[inline, virtual]`

| Return the center of the tetrahedron in parametric coordinates. Reimplemented from vtkCell. Definition at line 175 of file vtkTetra.h.

void vtkTetra::TetraCenter | ( | float | p1[3],
|  | float | p2[3],
|  | float | p3[3],
|  | float | p4[3],
|  | float | center[3]
| ) | `[static]`

| Compute the center of the tetrahedron,

double vtkTetra::Circumsphere | ( | double | p1[3],
|  | double | p2[3],
|  | double | p3[3],
|  | double | p4[3],
|  | double | center[3]
| ) | `[static]`

| Compute the circumcenter (center[3]) and radius (method return value) of a tetrahedron defined by the four points x1, x2, x3, and x4.

double vtkTetra::Insphere | ( | double | p1[3],
|  | double | p2[3],
|  | double | p3[3],
|  | double | p4[3],
|  | double | center[3]
| ) | `[static]`

| Compute the center (center[3]) and radius (method return value) of a sphere that just fits inside the faces of a tetrahedron defined by the four points x1, x2, x3, and x4.

int vtkTetra::BarycentricCoords | ( | double | x[3],
|  | double | x1[3],
|  | double | x2[3],
|  | double | x3[3],
|  | double | x4[3],
|  | double | bcoords[4]
| ) | `[static]`

| Given a 3D point x[3], determine the barycentric coordinates of the point. Barycentric coordinates are a natural coordinate system for simplices that express a position as a linear combination of the vertices. For a tetrahedron, there are four barycentric coordinates (because there are four vertices), and the sum of the coordinates must equal 1. If a point x is inside a simplex, then all four coordinates will be strictly positive. If three coordinates are zero (so the fourth =1), then the point x is on a vertex. If two coordinates are zero, the point x is on an edge (and so on). In this method, you must specify the vertex coordinates x1->x4. Returns 0 if tetrahedron is degenerate.

double vtkTetra::ComputeVolume | ( | double | p1[3],
|  | double | p2[3],
|  | double | p3[3],
|  | double | p4[3]
| ) | `[static]`

| Compute the volume of a tetrahedron defined by the four points p1, p2, p3, and p4.

int vtkTetra::JacobianInverse | ( | double ** | inverse,
|  | float | derivs[12]
| ) |

| Given parametric coordinates compute inverse Jacobian transformation matrix. Returns 9 elements of 3x3 inverse Jacobian plus interpolation function derivatives. Returns 0 if no inverse exists.

void vtkTetra::InterpolationFunctions | ( | float | pcoords[3],
|  | float | weights[4]
| ) | `[static]`

| Tetra specific methods.

void vtkTetra::InterpolationDerivs | ( | float | derivs[12] | ) | `[static]`

| Tetra specific methods.

int* vtkTetra::GetEdgeArray | ( | int | edgeId | ) | `[static]`

| Tetra specific methods.

int* vtkTetra::GetFaceArray | ( | int | faceId | ) | `[static]`

| Tetra specific methods.

## Member Data Documentation

vtkLine* vtkTetra::Line`[protected]`

| Definition at line 167 of file vtkTetra.h.

vtkTriangle* vtkTetra::Triangle`[protected]`

| Definition at line 168 of file vtkTetra.h.

The documentation for this class was generated from the following file:

- Common/vtkTetra.h